#pragma once

#ifdef CSHOWINPUT_USECUDA
#include <cuda_runtime.h>
#include <cufft.h>
#endif //#ifdef CSHOWINPUT_USECUDA


class CShowInputView : public CView
{
protected: // create from serialization only
  CShowInputView();
  DECLARE_DYNCREATE(CShowInputView)

public:
//Constructors / Destructors
  ~CShowInputView(); //NOLINT(modernize-use-override)
  CShowInputView(const CShowInputView&) = delete;
  CShowInputView(CShowInputView&&) = delete;

//Methods
  CShowInputView& operator=(const CShowInputView&) = delete;
  CShowInputView& operator=(CShowInputView&&) = delete;
  CShowInputDoc* GetDocument() noexcept;
  void OnDraw(CDC* pDC) override;
  BOOL PreCreateWindow(CREATESTRUCT& cs) override;
  void OnInitialUpdate() override;
  static UINT _MonitorFunc(LPVOID pParam);
  UINT MonitorFunc();
  void DrawBars(CDC* pDC, const CRect& rClient);
#ifndef CSHOWINPUT_NOD2D
  LRESULT OnDraw2D(WPARAM wParam, LPARAM lParam);
  LRESULT OnRecreatedResources(WPARAM wParam, LPARAM lParam);
  HRESULT Draw(_In_ CRenderTarget* pRenderTarget);
  void DrawBars(CRenderTarget* pRenderTarget, const CRect& rClient);
#endif //#ifndef CSHOWINPUT_NOD2D

//Member variables
  short m_inbuffer[1024]; //NOLINT(modernize-avoid-c-arrays)
#ifdef CSHOWINPUT_USECUDA
  cufftHandle m_FFTPlan;
  cufftComplex m_InHost[1024];
  cufftComplex* m_InDevice;
  cufftComplex* m_OutDevice;
  cufftComplex  m_OutHost[1024];
#else
  double m_RealIn[1024]; //NOLINT(modernize-avoid-c-arrays)
  double m_ImagIn[1024]; //NOLINT(modernize-avoid-c-arrays)
  double m_RealOut[1024]; //NOLINT(modernize-avoid-c-arrays)
  double m_ImagOut[1024]; //NOLINT(modernize-avoid-c-arrays)
#endif //#ifdef CSHOWINPUT_USECUDA
  double m_Power[1024]; //NOLINT(modernize-avoid-c-arrays)
  CWinThread* m_pThread;
  volatile BOOL m_bWantStop;

//Message handlers
  afx_msg void OnDestroy();
  afx_msg BOOL OnEraseBkgnd(CDC* pDC);

  DECLARE_MESSAGE_MAP()
};
